// deskcutFxns.js
// assorted functions we'll need....

// -----------------------------------------------------------------------------
// -- stripBad(filename)
function stripBad(filename) {
  // OK; need to yank anything that will kill our happy shortcut filename
  filename = filename.replace(/[\\\/\:\*\?\"\<\>\|]/g, '');
  filename = filename.replace(/(^[\s]+)|([\s]+$)/g, '');
  return filename;
}

// -----------------------------------------------------------------------------
// -- getDateStamp ()
function getDateStamp () {
  var t = new Date();
  var stamp = t.getFullYear()+'';
  stamp=stamp+t.getMonth()+1+'';
  stamp=stamp+t.getDate()+'';
  stamp=stamp+t.getHours()+'';
  stamp=stamp+t.getMinutes()+'';
  stamp=stamp+t.getSeconds()+'';
  stamp=stamp+Lpad(t.getMilliseconds()+'',3,"0")
  return stamp;
}

// -----------------------------------------------------------------------------
// -- getOS()
function getOS() {
  var retVal = '';
  if (typeof(window.navigator.platform) != 'undefined') {
    var platform = window.navigator.platform.toLowerCase();
    if (platform.indexOf('win') != -1)
      retVal = 'win';
    else if (platform.indexOf('mac') != -1)
      retVal = 'mac';
    else if (platform.indexOf('linux') != -1)
      retVal = 'lin';
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- getDesktop () {
function getDesktop () {
  var retVal = '';
  var theOS = getOS();
  if (theOS == 'win') {
    retVal = getWinDesktop ()
  } else if (theOS == 'lin') {
    retVal = getLinDesktop
  } else if (theOS == 'mac') {

  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- getWinDesktop ()
function getWinDesktop () {
  var retVal = '';
  var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
  var winDesktop = dirService.get('DeskV', Components.interfaces.nsILocalFile);
  if (winDesktop.exists()) {
    retVal =  winDesktop.path;
  } else  {
    winDesktop = dirService.get('Favs', Components.interfaces.nsILocalFile);
    if (winDesktop.exists()) {
      retVal = winDesktop.path;
    }
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- isKdeInstalled ()
function isKdeInstalled () {
  var retVal = false;
  var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
  var linHome = dirService.get('Home', Components.interfaces.nsILocalFile);
  if (linHome.exists()) {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filePath = linHome.path + "//Desktop//";
    file.initWithPath (filePath);
    if (file.exists()) {
      retVal = true;
    }
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- isGnomeInstalled()
function isGnomeInstalled() {
  var retVal = false;
  var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
  var linHome = dirService.get('Home', Components.interfaces.nsILocalFile);
  if (linHome.exists()) {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filePath = linHome.path + + "//.gnome-desktop//";
    file.initWithPath (filePath);
    if (file.exists()) {
      retVal = true;
    }
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- getLinDesktop ()
function getLinDesktop () {
  var retVal = ''
  var KDE_installed = isKdeInstalled ();
  var GNOME_installed = isGnomeInstalled();
  if (KDE_installed == true) {
      if (GNOME_installed == true) {
        // Both GNOME and KDE installed, so pick one...
        //retval = pickGnomeOrKde();
        return (linHome.path + "//Desktop//");
      } else {
        return (linHome.path + "//Desktop//");
      }
    } else {
      if (GNOME_installed == true) {
        retVal = linHome.path + "//.gnome-desktop//";
      }
    }
    return retVal;
}

// -----------------------------------------------------------------------------
// -- pickGnomeOrKde()
function pickGnomeOrKde() {

}

// -----------------------------------------------------------------------------
// -- getBundle(bundleString)
// ---- return a string from the strings bundle named bundleString
function getBundle (strName) {
  var retVal = "";
  if (gdeskcutBundle) {
    try {
      retVal = gdeskcutBundle.getString(strName);
    } catch (e) {
    }
  }
  return retVal;
}

// -----------------------------------------------------------------------------
// -- pathPrompt(dTitle)
// prompt for a path using dTitle as the bundle string for the dialog box
function pathPrompt(dTitle) {
  var dialogTitle = getBundle (dTitle);
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const nsILocalFile = Components.interfaces.nsILocalFile;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, dialogTitle , nsIFilePicker.modeGetFolder);
	fp.appendFilters(nsIFilePicker.filterAll);
	var ret = fp.show();
	if (ret == nsIFilePicker.returnOK) {
		var localFile = fp.file.QueryInterface(nsILocalFile);
		var daPath = fp.file.path;
    return daPath;
	}
		else if (ret == nsIFilePicker.returnCancel) {
      return ""
	}
}

// -----------------------------------------------------------------------------
// -- filePrompt(dTitle,filterString, filterType)
// prompt for a file using dTitle as the bundle string for the dialog box
// filter files specified by filterType
// filePrompt ("Wav file to play","WAV FILES","*.wav")
function filePrompt(dTitle,filterString,filterType) {
  var dialogTitle = getBundle (dTitle);
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const nsILocalFile = Components.interfaces.nsILocalFile;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, dialogTitle , nsIFilePicker.modeOpen);
  if (filterString == "" || filterType == "" ) {
    fp.appendFilters("All Files","*.*");
  } else {
    fp.appendFilter(filterString,filterType);
  }
	var ret = fp.show();
	if (ret == nsIFilePicker.returnOK) {
		var localFile = fp.file.QueryInterface(nsILocalFile);
		var daPath = fp.file.path;
    return daPath;
	}
		else if (ret == nsIFilePicker.returnCancel) {
      return ""
	}
}

// -----------------------------------------------------------------------------
// -- doPrompt(dPrompt)
// -- returns a simple prompt using the passed in var as the prompt
function doPrompt(dPrompt) {
  var dialogPrompt = getBundle (dPrompt);
  var retVal = prompt(dialogPrompt);
  return retVal;
}

// -----------------------------------------------------------------------------
// -- Lpad(number,length,padChar)
// ---- Left pad number to length with padChar
// ---- Lpad(123,5,"0") would return 00123 as a string
function Lpad(number,length,padChar) {
  var retVal = '' + number;
  while (retVal.length < length) {
    retVal = padChar + retVal;
  }
  return retVal;
}
  
